;***************************************************
; Generation 500 kHz BFO ( Q=20 MHz )
;		 by Pavluk Vasyl
;    e-mail: vpawluk@hotmail.com
;***************************************************

	processor 12f629
	include   <P12f629.inc>

;	__CONFIG _CP_ON & _PWRTE_ON & _WDT_OFF & _EC_OSC & _MCLRE_OFF & _CPD_OFF & _BODEN_ON 	; GEN
	__CONFIG _CP_ON & _PWRTE_ON & _WDT_OFF & _HS_OSC & _MCLRE_OFF & _CPD_OFF & _BODEN_ON

;****************************************************************
;*			REGISTERS											*
;****************************************************************
#define		Phase1	GPIO,0			; Phase1 of OUT
#define		Phase2	GPIO,1			; Phase2 of OUT
#define		Phase3	GPIO,2			; Phase3 of OUT
#define		SELECT	GPIO,3			; SIN or KEY_mode
;****************************************************************
			org	0					;
			goto	SETUP			; Go to Setup
									;
;****************************************************************
			org	4					;
;****************************************************************
;			SETUP												*
;****************************************************************
SETUP		movlw	b'11111000'		; SET "0" at Phase_1,Phase_2,
			movwf	GPIO			; Phase_3,Phase_4
									;
			movlw	b'00001111'		; 
			movwf	CMCON			; B7=0 not used ( readed as 0 )
									; B6=0 CMOUT 
									; B5=0 not used ( readed as 0 )
									; B4=0 CINV ( not inverted out )
									; B3=1 CIS
									; B2..B0=111 ( comparator aff ) 
									;
			bsf		STATUS,RP0		; Bank 1
									;
			movlw	b'11111000'		; GP0,GP1,GP2 = OUT
			movwf	TRISIO			; GP3,GP4	  =INPUT
									;
			movlw	b'10000000'		; Pull-up GPIO-Enable
			movwf	OPTION_REG		; B7=1,pull-up disabled
									; B6=0 (INTEDG-int at H/L)
									; B5=0 (TOSC-internal)
									; B4=0 (TOSE)
									; B3=0 (PSA)
									; B2..B0 = 00 prescaller koef
									;
			movlw	b'00000000'		; Pull-up GPIO-Enable
			movwf	WPU				; detailed setting
									; B7,B6 = not used ( readed as 0 )
									; B5,B4 = pull up for GP5,GP4
									;  ( 1 = pull up is ON )
									; B3=not used ( readed as 0 )
									; B2..B0 = pull up for GP2..GP0
									;  ( 1 = pull up is ON )
									;
			bcf		STATUS,RP0		; Return to bank 0
									;
;************************************************************
			btfss	SELECT			;
			GOTO	KEY_MIX			;
;************************************************************
;				MAIN										*
;	GENERATION 500 kHz ( pseudo sinusoidal )	at Q=20MHz	*
;************************************************************
SIN_500		bsf		Phase3			;
			bsf		Phase1			;
			bsf		Phase2			;
			NOP						;
			NOP						;
			bcf		Phase2			;
			bcf		Phase1			;
			bcf		Phase3			;
			GOTO	SIN_500			;
;************************************************************
;				MAIN										*
;	GENERATION 500 kHz ( SW mode and meandre )	at Q=20MHz	*
;************************************************************
KEY_MIX		bcf		Phase3			;
			bsf		Phase1			;
			bsf		Phase2			;
			NOP						;
			NOP						;
			bcf		Phase2			;
			bcf		Phase1			;
			bsf		Phase3			;
			GOTO	KEY_MIX			; 
;************************************************************
			org		0x3ff			;
;************************************************************
			retlw	0xe4			; a8 = 4  MHz 
;************************************************************
			end
